/*
Majestic Map Engine

(C) 2011 Flying Jester Entertainment

"Because A Flying Jester Would Be Very Entertaining Indeed!"
*/

function MjEngineMap(map){
	this.mapim = LoadSurface(map+"/map.tga");
	this.width = this.mapim.width
	this.height = this.mapim.height
  this.controltile = LoadSurface(map+"/r0g0b0.tga")
	this.tilesize = this.controltile.width
	this.tileimages = []
	this.tileset = []
	this.maptilecon = []
	var i = 0
	var pixelcolor = ""
	var tilesame = false
		while(i<this.width){
			this.maptilecon.push(new Array)
			for (e=0;e<this.height;e++){
			this.maptilecon[i][e] = 0
			tilesame = false
			pixelcolor = "r"+this.mapim.getPixel(i, e).red+"g"+this.mapim.getPixel(i, e).green+"b"+this.mapim.getPixel(i, e).blue
				for (o=0;o<this.tileset.length;o++){
				if (this.tileset[o]==pixelcolor) {tilesame = true; this.maptilecon[i][e] = o}
				}
			if (!tilesame) {this.tileset.push(pixelcolor);  this.maptilecon[i][e] = this.tileset.length-1}
			}
		i++;
		}
this.tileimages = []
i = 0
	while(i<this.tileset.length){
	this.tileimages[i]=LoadSurface(map+"/"+this.tileset[i]+".tga")
	i++
	}
this.image = drawMap(this)
}


function drawMap0(map, camera){
if (camera==undefined) {this.camx = 0; this.camy = 0}
else
{this.camx = camera.x; this.camy = camera.y}
i = 0
	while((i<map.width))
	{
		for (e=0;e<=map.height;e++){
		if((map.maptilecon[i][e]!=undefined)) map.tileimages[map.maptilecon[i][e]].blit(i*map.tilesize-this.camx, e*map.tilesize-this.camy);
		}
	i++;
	}
}


//this one will use all surfaces

function drawMap(map){
var mainsurface = CreateSurface(map.width*map.tilesize, map.height*map.tilesize, CreateColor(0, 0, 0, 255))
i = 0
	while((i<map.width))
	{
		for (e=0;e<=map.height;e++){
		if((map.maptilecon[i][e]!=undefined)) mainsurface.blitSurface(map.tileimages[map.maptilecon[i][e]], i*map.tilesize, e*map.tilesize);
		}
	i++;
	}
return mainsurface
}

//this one will use all surfaces

function blitMap(map, camera){
map.blit(-camera.x, -camera.y)

}

